#include "C:\Users\Lluis\Projectes\llado\PIC\CamCtrl.h"

unsigned char timerEnable;
unsigned int16 triggerCount;
unsigned int16 counter;

void cameraTrigger ();

#int_TIMER0
TIMER0_isr()  // activates every 1.1ms
{
   if ( timerEnable == 1 )
   {
      if ( counter > 0 )
      {
         counter--;
      }
      else
      {
         counter = triggerCount;
         cameraTrigger();
      }
   }
}

// generates a pulse for the camer trigger outputs
void cameraTrigger ()
{
   output_high(PIN_A1);
   output_high(PIN_A2);
   delay_ms(100);
   output_low(PIN_A1);
   output_low(PIN_A2);
}

// main function
void main()
{

   unsigned char selector;

   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_OFF);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   enable_interrupts(INT_TIMER0);
   enable_interrupts(GLOBAL);

   timerEnable = 0;
   output_low(PIN_A1);  // puts the camera control bits to '0'
   output_low(PIN_A2);

   // infinit main bucle
   while(1)
   {
      selector = input_c() ^ 0xFF;   // gets the port C actual byte value and XOR with FF to switch '1's with '0's
      selector = selector & 0x0F;   // clear the higest 4 bits
      switch (selector)
      {
         case 0:
            triggerCount = 0;
         break;
         case 1:
            triggerCount = 1719;  //0,5fps
         break;
         case 2:
            triggerCount = 810;  //1fps
         break;
         case 3:
            triggerCount = 600;  //1,3fps
         break;
         case 4:
            triggerCount = 469;  //1,6fps
         break;
         case 5:
            triggerCount = 355;  //2fps
         break;
         case 6:
            triggerCount = 296;  //2,3fps
         break;
         case 7:
            triggerCount = 250;  //2,6fps
         break;
         case 8:
            triggerCount = 204;  //3fps
         break;
         case 9:
            triggerCount = 160;  //3,5fps    
         break;
      }

      if (!input(PIN_A0))
      {
         if (triggerCount == 0)  // manual mode
         {
            timerEnable = 0;
            cameraTrigger();
            while ( !input(PIN_A0) );   // waits for push button released
         }
         else  // automatic mode
         {
            set_timer0(250);
            timerEnable = 1;
            counter = triggerCount;
            while ( !input(PIN_A0) );   // waits for push button released
            delay_ms(400);
            while (input(PIN_A0));      // waits for push button pressed
            timerEnable = 0;
            while ( !input(PIN_A0) );   // waits for push button released
         }
      }

   }
}
